/*
    Import a JSON file, an array of pairs name and object
    The object hold columns as properties
    and a property is the content.
    A SQLite database must be converted to this format before to be loaded.
    
    Function are also added to parse the content, get an item, add or replace an item.
    
    (c) 2018 Scriptol.com
*/

var idb = null

function importIDB(dname, sname, arr) {
    var r = indexedDB.open(dname)
    var store
    r.onupgradeneeded = function() {
        idb = r.result;
        store = idb.createObjectStore(sname)
    }
    r.onsuccess = function(e) {
        idb = r.result
        let tactn = idb.transaction([sname], "readwrite")
        store = tactn.objectStore(sname)
        for(var i in arr) {
            store.add(arr[i], i)
        }           
    }
    r.onerror = function (e) {
        alert("Can't open IndexedDB: " + e.target.errorCode)
    }    
}

function displayIDB(idb, sname, id) {
    let storage = document.getElementById(id)
    let tactn = idb.transaction([s
    name])
    let store = tactn.objectStore(sname)
    let oss = store.openCursor()
    oss.onsuccess = function(e) {
        let cursor = e.target.result
        if (cursor) {
            storage.innerHTML += "Name " + cursor.key + " : " + cursor.value.name + "<br>")
            cursor.continue()
        }
    }    
}

function errorIDB()  {
    alert("Enable to access IndexedDB")
}

function getIDB(idb, sname, name, id) {
    var storage = document.getElementById(id)
    let tactn = idb.transaction([sname])
    let store = tactn.objectStore(sname)
    let data = store.get(data)
    data.onsuccess = function() {
        storage.innerHTML += "Name " + name + " : " + data.result.name + "<br>")
    }
    data.onerror = function(e) errorIDB()
}

function putIDB(idb, sname, key, data) {
    let tactn = idb.transaction([sname], "readwrite")
    let store = tactn.objectStore(sname) 
    let rupd = objectStore.put(data, key)
    rupd.onerror = function(e) errorIDB()
}